;This is the first load which compiles and executes to $400
;The actual program is a simple slideshow based on the number of files always held in FFF9

;Disk Routines
#define	DSK_DiskLoad	$FE00	;Disk LOAD routine Vector
;Disk Stats
#define DSK_TrackSide	$FFF0	;Refer to Manual for more info
#define DSK_Version	$FFF1
#define DSK_Sectors	$FFF2
#define DSK_FDCOffset	$FFF3
#define DSK_Machine	$FFF4
#define DSK_FirstLoadHi	$FFF5
#define	DSK_NumberFiles	$FFF9
;VIA stuff
#define via_portb       $0300
#define via_pcr         $030C
#define via_ier		$030E
#define via_porta       $030F
;Code for HIRES Switch
#define chr_Hires	28


 .zero
*=$00

FilePointer	.dsb 1
screen		.dsb 2
source		.dsb 2

 .text

;This code should load into $400
*=$400

driver	;Ensure all interrupts are disabled
	lda #$7F
	sta via_ier

	;Switch to HIRES for placing switch in bottom right of screen
	;Also copy text character set to HIRES set.
	jsr SoftHIRES

	;Setup First file pointer
	lda #01
	sta FilePointer

	;Load file to C000-DFFF
.(
loop1	ldx FilePointer
	lda #$C0
	jsr DSK_DiskLoad

	;Move to A000-BF3F
	jsr DisplayScreen

	;Display Screen name
	jsr DisplayPrompt

	;Wait upon Key
	jsr WaitOnKey

	;Progress File Pointer
	jsr UpdateFilePointer

	;Loop back to load next screen
	jmp loop1
.)

;This code increments the filepointer until it is greater than the number of files
;at which point it will point to the first one again.
UpdateFilePointer
	lda FilePointer
	clc
	adc #01
	cmp DSK_NumberFiles
.(
	bcc skip1
	lda #1
skip1	sta FilePointer
.)
	rts

;Display Screen name
DisplayPrompt
	ldx #39
.(
loop1	lda ScreenPromptText,x
	sta $BF68,x
	dex
	bpl loop1
.)
	rts
ScreenPromptText
 .byt "Press any key to continue to next slide."

;Usually the process of switching to HIRES involves clearing HIRES too but it is
;unneccesary for this demo.
SoftHIRES
	;Switch screen to HIRES
	lda #chr_Hires
	sta $BFDF
	;Now copy charset from B500-B7FF >> 9900-9BFF
	ldx #00
.(
loop1	lda $B500,x
	sta $9900,x
	lda $B600,x
	sta $9A00,x
	lda $B700,x
	sta $9B00,x
	dex
	bne loop1
.)
	rts

;Display Screen by copying from C000-DF3F to A000-BF3F
DisplayScreen
	lda #<$C000
	sta source
	lda #>$C000
	sta source+1
	lda #<$A000
	sta screen
	lda #>$A000
	sta screen+1
	ldx #200
.(
loop2	ldy #39
loop1	lda (source),y
	sta (screen),y
	dey
	bpl loop1
	jsr nl_source
	jsr nl_screen
	dex
	bne loop2
.)
	rts


;These are common routines used to update the next screen and source rows
nl_screen
	lda screen
	clc
	adc #40
	sta screen
	lda screen+1
	adc #00
	sta screen+1
	rts

nl_source
	lda source
	clc
	adc #40
	sta source
	lda source+1
	adc #00
	sta source+1
	rts

;Wait on key
WaitOnKey
	;Wait until no key
.(
loop1	jsr GetKey
	bcs loop1
.)
	;Wait on new key
.(
loop1	jsr GetKey
	bcc loop1
.)
	rts

;Scan all keys by poking Zero into Column register once and just scan all rows
GetKey	lda #$0E
	sta via_porta
	lda #$FF
	sta via_pcr
	ldx #$DD
	stx via_pcr
	lda #$00
	sta via_porta
	lda #$FD
	sta via_pcr
	stx via_pcr

	ldx #07
.(
loop2	stx via_portb
	;Wait a moment
	ldy #5
loop1	nop
	dey
	bpl loop1
	;then read back bit3 of portb
	lda via_portb
	and #8
	cmp #8	;This sets carry if keypressed
	beq skip1
	;proceed to remaining rows
	dex
	bpl loop2
	clc
skip1	;X holds Row
	rts
.)
